module Main where

import qualified Test.Synthesizer.LLVM.Filter as Filter
import qualified Test.Synthesizer.LLVM.Packed as Packed

import qualified LLVM.Core as LLVM

import Data.Tuple.HT (mapFst, )


prefix :: String -> [(String, IO ())] -> [(String, IO ())]
prefix msg =
   map (mapFst (\str -> msg ++ "." ++ str))

main :: IO ()
main = do
   LLVM.initializeNativeTarget
   mapM_ (\(name,test) -> putStr (name ++ ": ") >> test) $
      concat $
      prefix "Filter" Filter.tests :
      prefix "Packed" Packed.tests :
      []
